diff -Naur openssl-1.0.0q.orig/crypto/x509v3/pcy_cache.c openssl-1.0.0q/crypto/x509v3/pcy_cache.c
--- openssl-1.0.0q.orig/crypto/x509v3/pcy_cache.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/pcy_cache.c	2017-04-25 16:23:40.862798481 +0200
@@ -56,7 +56,8 @@
  *
  */
 
-#include "cryptlib.h"
+#if !defined OPERA_SMALL_VERSION || defined OPERA_NEED_POLICY_FUN
+#include <openssl/cryptlib.h>
 #include <openssl/x509.h>
 #include <openssl/x509v3.h>
 
@@ -134,7 +135,7 @@
 	CERTIFICATEPOLICIES *ext_cpols = NULL;
 	POLICY_MAPPINGS *ext_pmaps = NULL;
 	int i;
-	cache = OPENSSL_malloc(sizeof(X509_POLICY_CACHE));
+	cache = (X509_POLICY_CACHE *) OPENSSL_malloc(sizeof(X509_POLICY_CACHE));
 	if (!cache)
 		return 0;
 	cache->anyPolicy = NULL;
@@ -148,7 +149,7 @@
 	/* Handle requireExplicitPolicy *first*. Need to process this
 	 * even if we don't have any policies.
 	 */
-	ext_pcons = X509_get_ext_d2i(x, NID_policy_constraints, &i, NULL);
+	ext_pcons = (POLICY_CONSTRAINTS *) X509_get_ext_d2i(x, NID_policy_constraints, &i, NULL);
 
 	if (!ext_pcons)
 		{
@@ -170,7 +171,7 @@
 
 	/* Process CertificatePolicies */
 
-	ext_cpols = X509_get_ext_d2i(x, NID_certificate_policies, &i, NULL);
+	ext_cpols = (CERTIFICATEPOLICIES *) X509_get_ext_d2i(x, NID_certificate_policies, &i, NULL);
 	/* If no CertificatePolicies extension or problem decoding then
 	 * there is no point continuing because the valid policies will be
 	 * NULL.
@@ -190,7 +191,7 @@
 	if (i <= 0)
 		return i;
 
-	ext_pmaps = X509_get_ext_d2i(x, NID_policy_mappings, &i, NULL);
+	ext_pmaps = (POLICY_MAPPINGS *) X509_get_ext_d2i(x, NID_policy_mappings, &i, NULL);
 
 	if (!ext_pmaps)
 		{
@@ -205,7 +206,7 @@
 			goto bad_cache;
 		}
 
-	ext_any = X509_get_ext_d2i(x, NID_inhibit_any_policy, &i, NULL);
+	ext_any = (ASN1_INTEGER *) X509_get_ext_d2i(x, NID_inhibit_any_policy, &i, NULL);
 
 	if (!ext_any)
 		{
@@ -284,3 +285,4 @@
 	*out = ASN1_INTEGER_get(value);
 	return 1;
 	}
+#endif // !defined OPERA_SMALL_VERSION || defined OPERA_NEED_POLICY_FUN
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/pcy_data.c openssl-1.0.0q/crypto/x509v3/pcy_data.c
--- openssl-1.0.0q.orig/crypto/x509v3/pcy_data.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/pcy_data.c	2017-04-25 16:23:40.863798329 +0200
@@ -56,7 +56,8 @@
  *
  */
 
-#include "cryptlib.h"
+#if !defined OPERA_SMALL_VERSION || defined OPERA_NEED_POLICY_FUN
+#include <openssl/cryptlib.h>
 #include <openssl/x509.h>
 #include <openssl/x509v3.h>
 
@@ -97,9 +98,13 @@
 		}
 	else
 		id = NULL;
-	ret = OPENSSL_malloc(sizeof(X509_POLICY_DATA));
+	ret = (X509_POLICY_DATA *)OPENSSL_malloc(sizeof(X509_POLICY_DATA));
 	if (!ret)
+	{
+		if (id)
+			ASN1_OBJECT_free(id);
 		return NULL;
+	}
 	ret->expected_policy_set = sk_ASN1_OBJECT_new_null();
 	if (!ret->expected_policy_set)
 		{
@@ -133,3 +138,4 @@
 	return ret;
 	}
 
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/pcy_lib.c openssl-1.0.0q/crypto/x509v3/pcy_lib.c
--- openssl-1.0.0q.orig/crypto/x509v3/pcy_lib.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/pcy_lib.c	2017-04-25 16:23:40.863798329 +0200
@@ -57,7 +57,8 @@
  */
 
 
-#include "cryptlib.h"
+#if !defined OPERA_SMALL_VERSION || defined OPERA_NEED_POLICY_FUN
+#include <openssl/cryptlib.h>
 #include <openssl/x509.h>
 #include <openssl/x509v3.h>
 
@@ -82,6 +83,7 @@
 	return tree->levels + i;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 STACK_OF(X509_POLICY_NODE) *
 		X509_policy_tree_get0_policies(const X509_POLICY_TREE *tree)
 	{
@@ -89,6 +91,7 @@
 		return NULL;
 	return tree->auth_policies;
 	}
+#endif
 
 STACK_OF(X509_POLICY_NODE) *
 	X509_policy_tree_get0_user_policies(const X509_POLICY_TREE *tree)
@@ -156,6 +159,7 @@
 	return node->data->qualifier_set;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 const X509_POLICY_NODE *
 		X509_policy_node_get0_parent(const X509_POLICY_NODE *node)
 	{
@@ -165,3 +169,5 @@
 	}
 
 
+#endif
+#endif // !defined OPERA_SMALL_VERSION || defined OPERA_NEED_POLICY_FUN
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/pcy_map.c openssl-1.0.0q/crypto/x509v3/pcy_map.c
--- openssl-1.0.0q.orig/crypto/x509v3/pcy_map.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/pcy_map.c	2017-04-25 16:23:40.864798177 +0200
@@ -56,7 +56,8 @@
  *
  */
 
-#include "cryptlib.h"
+#if !defined OPERA_SMALL_VERSION || defined OPERA_NEED_POLICY_FUN
+#include <openssl/cryptlib.h>
 #include <openssl/x509.h>
 #include <openssl/x509v3.h>
 
@@ -130,3 +131,4 @@
 	return ret;
 
 	}
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/pcy_node.c openssl-1.0.0q/crypto/x509v3/pcy_node.c
--- openssl-1.0.0q.orig/crypto/x509v3/pcy_node.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/pcy_node.c	2017-04-25 16:23:40.864798177 +0200
@@ -56,6 +56,7 @@
  *
  */
 
+#if !defined OPERA_SMALL_VERSION || defined OPERA_NEED_POLICY_FUN
 #include <openssl/asn1.h>
 #include <openssl/x509.h>
 #include <openssl/x509v3.h>
@@ -115,7 +116,7 @@
 			X509_POLICY_TREE *tree)
 	{
 	X509_POLICY_NODE *node;
-	node = OPENSSL_malloc(sizeof(X509_POLICY_NODE));
+	node = (X509_POLICY_NODE *) OPENSSL_malloc(sizeof(X509_POLICY_NODE));
 	if (!node)
 		return NULL;
 	node->data = data;
@@ -195,3 +196,4 @@
 	return 0;
 
 	}
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/pcy_tree.c openssl-1.0.0q/crypto/x509v3/pcy_tree.c
--- openssl-1.0.0q.orig/crypto/x509v3/pcy_tree.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/pcy_tree.c	2017-04-25 16:23:40.865798304 +0200
@@ -56,12 +56,13 @@
  *
  */
 
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 #include <openssl/x509.h>
 #include <openssl/x509v3.h>
 
 #include "pcy_int.h"
 
+#if !defined OPERA_SMALL_VERSION || defined OPERA_NEED_POLICY_FUN
 /* Enable this to print out the complete policy tree at various point during
  * evaluation.
  */
@@ -219,13 +220,13 @@
 
 	/* If we get this far initialize the tree */
 
-	tree = OPENSSL_malloc(sizeof(X509_POLICY_TREE));
+	tree = (X509_POLICY_TREE *) OPENSSL_malloc(sizeof(X509_POLICY_TREE));
 
 	if (!tree)
 		return 0;
 
 	tree->flags = 0;
-	tree->levels = OPENSSL_malloc(sizeof(X509_POLICY_LEVEL) * n);
+	tree->levels = (X509_POLICY_LEVEL *) OPENSSL_malloc(sizeof(X509_POLICY_LEVEL) * n);
 	tree->nlevel = 0;
 	tree->extra_data = NULL;
 	tree->auth_policies = NULL;
@@ -237,7 +238,7 @@
 		return 0;
 		}
 
-	memset(tree->levels, 0, n * sizeof(X509_POLICY_LEVEL));
+	op_memset(tree->levels, 0, n * sizeof(X509_POLICY_LEVEL));
 
 	tree->nlevel = n;
 
@@ -550,9 +551,9 @@
 			return 1;
 			}
 		}
-
+#ifndef OPERA_SMALL_VERSION
 	return 1;
-
+#endif
 	}
 
 static int tree_add_auth_node(STACK_OF(X509_POLICY_NODE) **pnodes,
@@ -639,6 +640,7 @@
 
 	X509_POLICY_NODE *anyPolicy;
 	X509_POLICY_DATA *extra;
+	BOOL alloced_node = FALSE;
 
 	/* Check if anyPolicy present in authority constrained policy set:
 	 * this will happen if it is a leaf node.
@@ -663,6 +665,7 @@
 		{
 		oid = sk_ASN1_OBJECT_value(policy_oids, i);
 		node = tree_find_sk(auth_nodes, oid);
+		alloced_node = FALSE;
 		if (!node)
 			{
 			if (!anyPolicy)
@@ -679,13 +682,18 @@
 						| POLICY_DATA_FLAG_EXTRA_NODE;
 			node = level_add_node(NULL, extra, anyPolicy->parent,
 						tree);
+			alloced_node = TRUE;
 			}
 		if (!tree->user_policies)
-			{
+		{
 			tree->user_policies = sk_X509_POLICY_NODE_new_null();
 			if (!tree->user_policies)
+			{
+				if(alloced_node)
+					policy_node_free(node);
 				return 1;
 			}
+		}
 		if (!sk_X509_POLICY_NODE_push(tree->user_policies, node))
 			return 0;
 		}
@@ -772,6 +780,8 @@
 	int ret;
 	X509_POLICY_TREE *tree = NULL;
 	STACK_OF(X509_POLICY_NODE) *nodes, *auth_nodes = NULL;
+	if(*ptree != NULL)
+		X509_policy_tree_free(*ptree);
 	*ptree = NULL;
 
 	*pexplicit_policy = 0;
@@ -869,4 +879,4 @@
 	return 0;
 
 	}
-
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/tabtest.c openssl-1.0.0q/crypto/x509v3/tabtest.c
--- openssl-1.0.0q.orig/crypto/x509v3/tabtest.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/tabtest.c	2017-04-25 16:23:40.866798710 +0200
@@ -60,7 +60,9 @@
  * problems if it is not.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include <openssl/x509v3.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_addr.c openssl-1.0.0q/crypto/x509v3/v3_addr.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_addr.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_addr.c	2017-04-25 16:23:40.867798278 +0200
@@ -75,27 +75,27 @@
  * OpenSSL ASN.1 template translation of RFC 3779 2.2.3.
  */
 
-ASN1_SEQUENCE(IPAddressRange) = {
-  ASN1_SIMPLE(IPAddressRange, min, ASN1_BIT_STRING),
+ASN1_SEQUENCE(IPAddressRange)
+  ASN1_SIMPLE(IPAddressRange, min, ASN1_BIT_STRING)
   ASN1_SIMPLE(IPAddressRange, max, ASN1_BIT_STRING)
-} ASN1_SEQUENCE_END(IPAddressRange)
+ASN1_SEQUENCE_END(IPAddressRange)
 
-ASN1_CHOICE(IPAddressOrRange) = {
-  ASN1_SIMPLE(IPAddressOrRange, u.addressPrefix, ASN1_BIT_STRING),
+ASN1_CHOICE(IPAddressOrRange)
+  ASN1_SIMPLE(IPAddressOrRange, u.addressPrefix, ASN1_BIT_STRING
   ASN1_SIMPLE(IPAddressOrRange, u.addressRange,  IPAddressRange)
-} ASN1_CHOICE_END(IPAddressOrRange)
+ASN1_CHOICE_END(IPAddressOrRange)
 
-ASN1_CHOICE(IPAddressChoice) = {
-  ASN1_SIMPLE(IPAddressChoice,      u.inherit,           ASN1_NULL),
+ASN1_CHOICE(IPAddressChoice)
+  ASN1_SIMPLE(IPAddressChoice,      u.inherit,           ASN1_NULL)
   ASN1_SEQUENCE_OF(IPAddressChoice, u.addressesOrRanges, IPAddressOrRange)
-} ASN1_CHOICE_END(IPAddressChoice)
+ASN1_CHOICE_END(IPAddressChoice)
 
-ASN1_SEQUENCE(IPAddressFamily) = {
-  ASN1_SIMPLE(IPAddressFamily, addressFamily,   ASN1_OCTET_STRING),
+ASN1_SEQUENCE(IPAddressFamily) 
+  ASN1_SIMPLE(IPAddressFamily, addressFamily,   ASN1_OCTET_STRING)
   ASN1_SIMPLE(IPAddressFamily, ipAddressChoice, IPAddressChoice)
-} ASN1_SEQUENCE_END(IPAddressFamily)
+ASN1_SEQUENCE_END(IPAddressFamily)
 
-ASN1_ITEM_TEMPLATE(IPAddrBlocks) = 
+ASN1_ITEM_TEMPLATE(IPAddrBlocks)
   ASN1_EX_TEMPLATE_TYPE(ASN1_TFLG_SEQUENCE_OF, 0,
 			IPAddrBlocks, IPAddressFamily)
 ASN1_ITEM_TEMPLATE_END(IPAddrBlocks)
@@ -525,7 +525,7 @@
 					     const unsigned *safi)
 {
   IPAddressFamily *f;
-  unsigned char key[3];
+  unsigned char key[3]; /* ARRAY OK 2007-11-07 yngve */
   unsigned keylen;
   int i;
 
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_akey.c openssl-1.0.0q/crypto/x509v3/v3_akey.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_akey.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_akey.c	2017-04-25 16:23:40.868798406 +0200
@@ -56,29 +56,33 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/conf.h>
 #include <openssl/asn1.h>
 #include <openssl/asn1t.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 static STACK_OF(CONF_VALUE) *i2v_AUTHORITY_KEYID(X509V3_EXT_METHOD *method,
 			AUTHORITY_KEYID *akeyid, STACK_OF(CONF_VALUE) *extlist);
+#ifndef OPERA_SMALL_VERSION
 static AUTHORITY_KEYID *v2i_AUTHORITY_KEYID(X509V3_EXT_METHOD *method,
 			X509V3_CTX *ctx, STACK_OF(CONF_VALUE) *values);
+#endif
 
-const X509V3_EXT_METHOD v3_akey_id =
-	{
+CONST_X509V3_EXT_METHOD_item(v3_akey_id,
 	NID_authority_key_identifier,
 	X509V3_EXT_MULTILINE, ASN1_ITEM_ref(AUTHORITY_KEYID),
 	0,0,0,0,
 	0,0,
 	(X509V3_EXT_I2V)i2v_AUTHORITY_KEYID,
-	(X509V3_EXT_V2I)v2i_AUTHORITY_KEYID,
+	OPERA_V2I_DECLARE((X509V3_EXT_V2I)v2i_AUTHORITY_KEYID),
 	0,0,
 	NULL
-	};
+	);
 
 static STACK_OF(CONF_VALUE) *i2v_AUTHORITY_KEYID(X509V3_EXT_METHOD *method,
 	     AUTHORITY_KEYID *akeyid, STACK_OF(CONF_VALUE) *extlist)
@@ -108,6 +112,7 @@
  * this is always included.
  */
 
+#ifndef OPERA_SMALL_VERSION
 static AUTHORITY_KEYID *v2i_AUTHORITY_KEYID(X509V3_EXT_METHOD *method,
 	     X509V3_CTX *ctx, STACK_OF(CONF_VALUE) *values)
 	{
@@ -206,3 +211,4 @@
 	M_ASN1_OCTET_STRING_free(ikeyid);
 	return NULL;
 	}
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_akeya.c openssl-1.0.0q/crypto/x509v3/v3_akeya.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_akeya.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_akeya.c	2017-04-25 16:23:40.868798406 +0200
@@ -56,17 +56,21 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/conf.h>
 #include <openssl/asn1.h>
 #include <openssl/asn1t.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
-ASN1_SEQUENCE(AUTHORITY_KEYID) = {
-	ASN1_IMP_OPT(AUTHORITY_KEYID, keyid, ASN1_OCTET_STRING, 0),
-	ASN1_IMP_SEQUENCE_OF_OPT(AUTHORITY_KEYID, issuer, GENERAL_NAME, 1),
+ASN1_SEQUENCE(AUTHORITY_KEYID) 
+	ASN1_IMP_OPT(AUTHORITY_KEYID, keyid, ASN1_OCTET_STRING, 0)
+	ASN1_IMP_SEQUENCE_OF_OPT(AUTHORITY_KEYID, issuer, GENERAL_NAME, 1)
 	ASN1_IMP_OPT(AUTHORITY_KEYID, serial, ASN1_INTEGER, 2)
-} ASN1_SEQUENCE_END(AUTHORITY_KEYID)
+ASN1_SEQUENCE_END(AUTHORITY_KEYID)
+
+IMPLEMENT_ASN1_FUNCTIONS3(AUTHORITY_KEYID)
 
-IMPLEMENT_ASN1_FUNCTIONS(AUTHORITY_KEYID)
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_alt.c openssl-1.0.0q/crypto/x509v3/v3_alt.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_alt.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_alt.c	2017-04-25 16:23:40.869798253 +0200
@@ -56,39 +56,46 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/conf.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
+#ifndef OPERA_SMALL_VERSION
 static GENERAL_NAMES *v2i_subject_alt(X509V3_EXT_METHOD *method, X509V3_CTX *ctx, STACK_OF(CONF_VALUE) *nval);
 static GENERAL_NAMES *v2i_issuer_alt(X509V3_EXT_METHOD *method, X509V3_CTX *ctx, STACK_OF(CONF_VALUE) *nval);
 static int copy_email(X509V3_CTX *ctx, GENERAL_NAMES *gens, int move_p);
 static int copy_issuer(X509V3_CTX *ctx, GENERAL_NAMES *gens);
+#endif
 static int do_othername(GENERAL_NAME *gen, char *value, X509V3_CTX *ctx);
 static int do_dirname(GENERAL_NAME *gen, char *value, X509V3_CTX *ctx);
 
-const X509V3_EXT_METHOD v3_alt[] = {
-{ NID_subject_alt_name, 0, ASN1_ITEM_ref(GENERAL_NAMES),
+OPENSSL_PREFIX_CONST_ARRAY(OPENSSL_EXTERN,X509V3_EXT_METHOD, v3_alt, libopeay)
+
+CONST_X509V3_EXT_METHOD_ENTRY( NID_subject_alt_name, 0, ASN1_ITEM_ref(GENERAL_NAMES),
 0,0,0,0,
 0,0,
 (X509V3_EXT_I2V)i2v_GENERAL_NAMES,
-(X509V3_EXT_V2I)v2i_subject_alt,
-NULL, NULL, NULL},
+OPERA_V2I_DECLARE((X509V3_EXT_V2I)v2i_subject_alt),
+NULL, NULL, NULL)
 
-{ NID_issuer_alt_name, 0, ASN1_ITEM_ref(GENERAL_NAMES),
+CONST_X509V3_EXT_METHOD_ENTRY( NID_issuer_alt_name, 0, ASN1_ITEM_ref(GENERAL_NAMES),
 0,0,0,0,
 0,0,
 (X509V3_EXT_I2V)i2v_GENERAL_NAMES,
-(X509V3_EXT_V2I)v2i_issuer_alt,
-NULL, NULL, NULL},
+OPERA_V2I_DECLARE((X509V3_EXT_V2I)v2i_issuer_alt),
+NULL, NULL, NULL)
 
-{ NID_certificate_issuer, 0, ASN1_ITEM_ref(GENERAL_NAMES),
+CONST_X509V3_EXT_METHOD_ENTRY( NID_certificate_issuer, 0, ASN1_ITEM_ref(GENERAL_NAMES),
 0,0,0,0,
 0,0,
 (X509V3_EXT_I2V)i2v_GENERAL_NAMES,
-NULL, NULL, NULL, NULL},
-};
+NULL, NULL, NULL, NULL)
+
+CONST_END(v3_alt)
 
 STACK_OF(CONF_VALUE) *i2v_GENERAL_NAMES(X509V3_EXT_METHOD *method,
 		GENERAL_NAMES *gens, STACK_OF(CONF_VALUE) *ret)
@@ -107,7 +114,7 @@
 				GENERAL_NAME *gen, STACK_OF(CONF_VALUE) *ret)
 {
 	unsigned char *p;
-	char oline[256], htmp[5];
+	char oline[256], htmp[5];	/* ARRAY OK 2004-02-18 yngve */
 	int i;
 	switch (gen->type)
 	{
@@ -153,9 +160,9 @@
 				BIO_snprintf(htmp, sizeof htmp,
 					     "%X", p[0] << 8 | p[1]);
 				p += 2;
-				strcat(oline, htmp);
+				op_strcat(oline, htmp);
 				if (i != 7)
-					strcat(oline, ":");
+					op_strcat(oline, ":");
 				}
 			}
 		else
@@ -240,6 +247,7 @@
 	return 1;
 }
 
+#ifndef OPERA_SMALL_VERSION
 static GENERAL_NAMES *v2i_issuer_alt(X509V3_EXT_METHOD *method,
 				 X509V3_CTX *ctx, STACK_OF(CONF_VALUE) *nval)
 {
@@ -253,7 +261,7 @@
 	for(i = 0; i < sk_CONF_VALUE_num(nval); i++) {
 		cnf = sk_CONF_VALUE_value(nval, i);
 		if(!name_cmp(cnf->name, "issuer") && cnf->value &&
-						!strcmp(cnf->value, "copy")) {
+						!op_strcmp(cnf->value, "copy")) {
 			if(!copy_issuer(ctx, gens)) goto err;
 		} else {
 			GENERAL_NAME *gen;
@@ -318,10 +326,10 @@
 	for(i = 0; i < sk_CONF_VALUE_num(nval); i++) {
 		cnf = sk_CONF_VALUE_value(nval, i);
 		if(!name_cmp(cnf->name, "email") && cnf->value &&
-						!strcmp(cnf->value, "copy")) {
+						!op_strcmp(cnf->value, "copy")) {
 			if(!copy_email(ctx, gens, 0)) goto err;
 		} else if(!name_cmp(cnf->name, "email") && cnf->value &&
-						!strcmp(cnf->value, "move")) {
+						!op_strcmp(cnf->value, "move")) {
 			if(!copy_email(ctx, gens, 1)) goto err;
 		} else {
 			GENERAL_NAME *gen;
@@ -392,6 +400,7 @@
 	return 0;
 	
 }
+#endif // !OPERA_SMALL_VERSION
 
 GENERAL_NAMES *v2i_GENERAL_NAMES(const X509V3_EXT_METHOD *method,
 				 X509V3_CTX *ctx, STACK_OF(CONF_VALUE) *nval)
@@ -578,7 +587,7 @@
 	if (!(gen->d.otherName->value = ASN1_generate_v3(p + 1, ctx)))
 		return 0;
 	objlen = p - value;
-	objtmp = OPENSSL_malloc(objlen + 1);
+	objtmp = (char *)OPENSSL_malloc(objlen + 1);
 	strncpy(objtmp, value, objlen);
 	objtmp[objlen] = 0;
 	gen->d.otherName->type_id = OBJ_txt2obj(objtmp, 0);
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_asid.c openssl-1.0.0q/crypto/x509v3/v3_asid.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_asid.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_asid.c	2017-04-25 16:23:40.870798939 +0200
@@ -75,25 +75,25 @@
  * OpenSSL ASN.1 template translation of RFC 3779 3.2.3.
  */
 
-ASN1_SEQUENCE(ASRange) = {
-  ASN1_SIMPLE(ASRange, min, ASN1_INTEGER),
+ASN1_SEQUENCE(ASRange) 
+  ASN1_SIMPLE(ASRange, min, ASN1_INTEGER)
   ASN1_SIMPLE(ASRange, max, ASN1_INTEGER)
-} ASN1_SEQUENCE_END(ASRange)
+ASN1_SEQUENCE_END(ASRange)
 
-ASN1_CHOICE(ASIdOrRange) = {
-  ASN1_SIMPLE(ASIdOrRange, u.id,    ASN1_INTEGER),
+ASN1_CHOICE(ASIdOrRange)
+  ASN1_SIMPLE(ASIdOrRange, u.id,    ASN1_INTEGER)
   ASN1_SIMPLE(ASIdOrRange, u.range, ASRange)
-} ASN1_CHOICE_END(ASIdOrRange)
+ASN1_CHOICE_END(ASIdOrRange)
 
-ASN1_CHOICE(ASIdentifierChoice) = {
-  ASN1_SIMPLE(ASIdentifierChoice,      u.inherit,       ASN1_NULL),
+ASN1_CHOICE(ASIdentifierChoice)
+  ASN1_SIMPLE(ASIdentifierChoice,      u.inherit,       ASN1_NULL)
   ASN1_SEQUENCE_OF(ASIdentifierChoice, u.asIdsOrRanges, ASIdOrRange)
-} ASN1_CHOICE_END(ASIdentifierChoice)
+ASN1_CHOICE_END(ASIdentifierChoice)
 
-ASN1_SEQUENCE(ASIdentifiers) = {
-  ASN1_EXP_OPT(ASIdentifiers, asnum, ASIdentifierChoice, 0),
+ASN1_SEQUENCE(ASIdentifiers)
+  ASN1_EXP_OPT(ASIdentifiers, asnum, ASIdentifierChoice, 0)
   ASN1_EXP_OPT(ASIdentifiers, rdi,   ASIdentifierChoice, 1)
-} ASN1_SEQUENCE_END(ASIdentifiers)
+ASN1_SEQUENCE_END(ASIdentifiers)
 
 IMPLEMENT_ASN1_FUNCTIONS(ASRange)
 IMPLEMENT_ASN1_FUNCTIONS(ASIdOrRange)
@@ -654,7 +654,7 @@
 /*
  * OpenSSL dispatch.
  */
-const X509V3_EXT_METHOD v3_asid = {
+CONST_X509V3_EXT_METHOD_item(v3_asid,
   NID_sbgp_autonomousSysNum,	/* nid */
   0,				/* flags */
   ASN1_ITEM_ref(ASIdentifiers),	/* template */
@@ -666,7 +666,7 @@
   i2r_ASIdentifiers,		/* i2r */
   0,				/* r2i */
   NULL				/* extension-specific data */
-};
+)
 
 /*
  * Figure out whether extension uses inheritance.
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_bcons.c openssl-1.0.0q/crypto/x509v3/v3_bcons.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_bcons.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_bcons.c	2017-04-25 16:23:40.871797669 +0200
@@ -57,33 +57,38 @@
  */
 
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 #include <openssl/asn1t.h>
 #include <openssl/conf.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 static STACK_OF(CONF_VALUE) *i2v_BASIC_CONSTRAINTS(X509V3_EXT_METHOD *method, BASIC_CONSTRAINTS *bcons, STACK_OF(CONF_VALUE) *extlist);
+#ifndef OPERA_SMALL_VERSION
 static BASIC_CONSTRAINTS *v2i_BASIC_CONSTRAINTS(X509V3_EXT_METHOD *method, X509V3_CTX *ctx, STACK_OF(CONF_VALUE) *values);
+#endif
 
-const X509V3_EXT_METHOD v3_bcons = {
+CONST_X509V3_EXT_METHOD_item( v3_bcons,
 NID_basic_constraints, 0,
 ASN1_ITEM_ref(BASIC_CONSTRAINTS),
 0,0,0,0,
 0,0,
 (X509V3_EXT_I2V)i2v_BASIC_CONSTRAINTS,
-(X509V3_EXT_V2I)v2i_BASIC_CONSTRAINTS,
+OPERA_V2I_DECLARE((X509V3_EXT_V2I)v2i_BASIC_CONSTRAINTS),
 NULL,NULL,
 NULL
-};
+)
 
-ASN1_SEQUENCE(BASIC_CONSTRAINTS) = {
-	ASN1_OPT(BASIC_CONSTRAINTS, ca, ASN1_FBOOLEAN),
+ASN1_SEQUENCE(BASIC_CONSTRAINTS) 
+	ASN1_OPT(BASIC_CONSTRAINTS, ca, ASN1_FBOOLEAN)
 	ASN1_OPT(BASIC_CONSTRAINTS, pathlen, ASN1_INTEGER)
-} ASN1_SEQUENCE_END(BASIC_CONSTRAINTS)
+ASN1_SEQUENCE_END(BASIC_CONSTRAINTS)
 
-IMPLEMENT_ASN1_FUNCTIONS(BASIC_CONSTRAINTS)
+IMPLEMENT_ASN1_FUNCTIONS3(BASIC_CONSTRAINTS)
 
 
 static STACK_OF(CONF_VALUE) *i2v_BASIC_CONSTRAINTS(X509V3_EXT_METHOD *method,
@@ -94,6 +99,7 @@
 	return extlist;
 }
 
+#ifndef OPERA_SMALL_VERSION
 static BASIC_CONSTRAINTS *v2i_BASIC_CONSTRAINTS(X509V3_EXT_METHOD *method,
 	     X509V3_CTX *ctx, STACK_OF(CONF_VALUE) *values)
 {
@@ -106,9 +112,9 @@
 	}
 	for(i = 0; i < sk_CONF_VALUE_num(values); i++) {
 		val = sk_CONF_VALUE_value(values, i);
-		if(!strcmp(val->name, "CA")) {
+		if(!op_strcmp(val->name, "CA")) {
 			if(!X509V3_get_value_bool(val, &bcons->ca)) goto err;
-		} else if(!strcmp(val->name, "pathlen")) {
+		} else if(!op_strcmp(val->name, "pathlen")) {
 			if(!X509V3_get_value_int(val, &bcons->pathlen)) goto err;
 		} else {
 			X509V3err(X509V3_F_V2I_BASIC_CONSTRAINTS, X509V3_R_INVALID_NAME);
@@ -121,4 +127,5 @@
 	BASIC_CONSTRAINTS_free(bcons);
 	return NULL;
 }
+#endif
 
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_bitst.c openssl-1.0.0q/crypto/x509v3/v3_bitst.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_bitst.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_bitst.c	2017-04-25 16:23:40.872798355 +0200
@@ -56,59 +56,62 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/conf.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
-static BIT_STRING_BITNAME ns_cert_type_table[] = {
-{0, "SSL Client", "client"},
-{1, "SSL Server", "server"},
-{2, "S/MIME", "email"},
-{3, "Object Signing", "objsign"},
-{4, "Unused", "reserved"},
-{5, "SSL CA", "sslCA"},
-{6, "S/MIME CA", "emailCA"},
-{7, "Object Signing CA", "objCA"},
-{-1, NULL, NULL}
-};
-
-static BIT_STRING_BITNAME key_usage_type_table[] = {
-{0, "Digital Signature", "digitalSignature"},
-{1, "Non Repudiation", "nonRepudiation"},
-{2, "Key Encipherment", "keyEncipherment"},
-{3, "Data Encipherment", "dataEncipherment"},
-{4, "Key Agreement", "keyAgreement"},
-{5, "Certificate Sign", "keyCertSign"},
-{6, "CRL Sign", "cRLSign"},
-{7, "Encipher Only", "encipherOnly"},
-{8, "Decipher Only", "decipherOnly"},
-{-1, NULL, NULL}
-};
+OPENSSL_PREFIX_CONST_ARRAY(static, BIT_STRING_BITNAME, ns_cert_type_table, libopeay)
+	CONST_BIT_STRING_BITNAME_ENTRY(0, "SSL Client", "client")
+	CONST_BIT_STRING_BITNAME_ENTRY(1, "SSL Server", "server")
+	CONST_BIT_STRING_BITNAME_ENTRY(2, "S/MIME", "email")
+	CONST_BIT_STRING_BITNAME_ENTRY(3, "Object Signing", "objsign")
+	CONST_BIT_STRING_BITNAME_ENTRY(4, "Unused", "reserved")
+	CONST_BIT_STRING_BITNAME_ENTRY(5, "SSL CA", "sslCA")
+	CONST_BIT_STRING_BITNAME_ENTRY(6, "S/MIME CA", "emailCA")
+	CONST_BIT_STRING_BITNAME_ENTRY(7, "Object Signing CA", "objCA")
+	CONST_BIT_STRING_BITNAME_ENTRY(-1, NULL, NULL)
+CONST_END(ns_cert_type_table)
+
+OPENSSL_PREFIX_CONST_ARRAY(static, BIT_STRING_BITNAME, key_usage_type_table, libopeay)
+	CONST_BIT_STRING_BITNAME_ENTRY(0, "Digital Signature", "digitalSignature")
+	CONST_BIT_STRING_BITNAME_ENTRY(1, "Non Repudiation", "nonRepudiation")
+	CONST_BIT_STRING_BITNAME_ENTRY(2, "Key Encipherment", "keyEncipherment")
+	CONST_BIT_STRING_BITNAME_ENTRY(3, "Data Encipherment", "dataEncipherment")
+	CONST_BIT_STRING_BITNAME_ENTRY(4, "Key Agreement", "keyAgreement")
+	CONST_BIT_STRING_BITNAME_ENTRY(5, "Certificate Sign", "keyCertSign")
+	CONST_BIT_STRING_BITNAME_ENTRY(6, "CRL Sign", "cRLSign")
+	CONST_BIT_STRING_BITNAME_ENTRY(7, "Encipher Only", "encipherOnly")
+	CONST_BIT_STRING_BITNAME_ENTRY(8, "Decipher Only", "decipherOnly")
+	CONST_BIT_STRING_BITNAME_ENTRY(-1, NULL, NULL)
+CONST_END(key_usage_type_table)
 
 
-
-const X509V3_EXT_METHOD v3_nscert = EXT_BITSTRING(NID_netscape_cert_type, ns_cert_type_table);
-const X509V3_EXT_METHOD v3_key_usage = EXT_BITSTRING(NID_key_usage, key_usage_type_table);
+CONST_X509V3_EXT_METHOD_BITSTRING_item(v3_nscert, NID_netscape_cert_type, OPENSSL_GLOBAL_ARRAY_NAME(ns_cert_type_table));
+CONST_X509V3_EXT_METHOD_BITSTRING_item(v3_key_usage, NID_key_usage, OPENSSL_GLOBAL_ARRAY_NAME(key_usage_type_table));
 
 STACK_OF(CONF_VALUE) *i2v_ASN1_BIT_STRING(X509V3_EXT_METHOD *method,
 	     ASN1_BIT_STRING *bits, STACK_OF(CONF_VALUE) *ret)
 {
-	BIT_STRING_BITNAME *bnam;
-	for(bnam =method->usr_data; bnam->lname; bnam++) {
+	const BIT_STRING_BITNAME *bnam;
+	for(bnam = (const BIT_STRING_BITNAME *) method->usr_data; bnam->lname; bnam++) {
 		if(ASN1_BIT_STRING_get_bit(bits, bnam->bitnum)) 
 			X509V3_add_value(bnam->lname, NULL, &ret);
 	}
 	return ret;
 }
 	
+#ifndef OPERA_SMALL_VERSION
 ASN1_BIT_STRING *v2i_ASN1_BIT_STRING(X509V3_EXT_METHOD *method,
 	     X509V3_CTX *ctx, STACK_OF(CONF_VALUE) *nval)
 {
 	CONF_VALUE *val;
 	ASN1_BIT_STRING *bs;
 	int i;
-	BIT_STRING_BITNAME *bnam;
+	const BIT_STRING_BITNAME *bnam;
 	if(!(bs = M_ASN1_BIT_STRING_new())) {
 		X509V3err(X509V3_F_V2I_ASN1_BIT_STRING,ERR_R_MALLOC_FAILURE);
 		return NULL;
@@ -116,8 +119,8 @@
 	for(i = 0; i < sk_CONF_VALUE_num(nval); i++) {
 		val = sk_CONF_VALUE_value(nval, i);
 		for(bnam = method->usr_data; bnam->lname; bnam++) {
-			if(!strcmp(bnam->sname, val->name) ||
-				!strcmp(bnam->lname, val->name) ) {
+			if(!op_strcmp(bnam->sname, val->name) ||
+				!op_strcmp(bnam->lname, val->name) ) {
 				if(!ASN1_BIT_STRING_set_bit(bs, bnam->bitnum, 1)) {
 					X509V3err(X509V3_F_V2I_ASN1_BIT_STRING,
 						ERR_R_MALLOC_FAILURE);
@@ -137,5 +140,6 @@
 	}
 	return bs;
 }
+#endif
 	
 
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_conf.c openssl-1.0.0q/crypto/x509v3/v3_conf.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_conf.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_conf.c	2017-04-25 16:23:40.873798482 +0200
@@ -59,13 +59,16 @@
 
 
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <ctype.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/conf.h>
 #include <openssl/x509.h>
 #include <openssl/x509v3.h>
 
+#ifndef OPERA_SMALL_VERSION
 static int v3_check_critical(char **value);
 static int v3_check_generic(char **value);
 static X509_EXTENSION *do_ext_nconf(CONF *conf, X509V3_CTX *ctx, int ext_nid, int crit, char *value);
@@ -166,11 +169,12 @@
 		}
 
 	ext  = do_ext_i2d(method, ext_nid, crit, ext_struc);
-	if(method->it) ASN1_item_free(ext_struc, ASN1_ITEM_ptr(method->it));
+	if(method->it) ASN1_item_free((ASN1_VALUE *) ext_struc, ASN1_ITEM_ptr(method->it));
 	else method->ext_free(ext_struc);
 	return ext;
 
 	}
+#endif/* OPERA_SMALL_VERSION */
 
 static X509_EXTENSION *do_ext_i2d(const X509V3_EXT_METHOD *method, int ext_nid,
 				  int crit, void *ext_struc)
@@ -183,14 +187,14 @@
 	if (method->it)
 		{
 		ext_der = NULL;
-		ext_len = ASN1_item_i2d(ext_struc, &ext_der, ASN1_ITEM_ptr(method->it));
+		ext_len = ASN1_item_i2d((ASN1_VALUE *) ext_struc, &ext_der, ASN1_ITEM_ptr(method->it));
 		if (ext_len < 0) goto merr;
 		}
 	 else
 		{
 		unsigned char *p;
 		ext_len = method->i2d(ext_struc, NULL);
-		if(!(ext_der = OPENSSL_malloc(ext_len))) goto merr;
+		if(!(ext_der = (unsigned char *) OPENSSL_malloc(ext_len))) goto merr;
 		p = ext_der;
 		method->i2d(ext_struc, &p);
 		}
@@ -199,8 +203,8 @@
 	ext_oct->length = ext_len;
 
 	ext = X509_EXTENSION_create_by_NID(NULL, ext_nid, crit, ext_oct);
-	if (!ext) goto merr;
 	M_ASN1_OCTET_STRING_free(ext_oct);
+	if (!ext) goto merr;
 
 	return ext;
 
@@ -222,13 +226,14 @@
 	return do_ext_i2d(method, ext_nid, crit, ext_struc);
 }
 
+#ifndef OPERA_SMALL_VERSION
 /* Check the extension string for critical flag */
 static int v3_check_critical(char **value)
 {
 	char *p = *value;
-	if ((strlen(p) < 9) || strncmp(p, "critical,", 9)) return 0;
+	if ((op_strlen(p) < 9) || op_strncmp(p, "critical,", 9)) return 0;
 	p+=9;
-	while(isspace((unsigned char)*p)) p++;
+	while(op_isspace((unsigned char)*p)) p++;
 	*value = p;
 	return 1;
 }
@@ -238,12 +243,12 @@
 {
 	int gen_type = 0;
 	char *p = *value;
-	if ((strlen(p) >= 4) && !strncmp(p, "DER:", 4))
+	if ((op_strlen(p) >= 4) && !op_strncmp(p, "DER:", 4))
 		{
 		p+=4;
 		gen_type = 1;
 		}
-	else if ((strlen(p) >= 5) && !strncmp(p, "ASN1:", 5))
+	else if ((op_strlen(p) >= 5) && !op_strncmp(p, "ASN1:", 5))
 		{
 		p+=5;
 		gen_type = 2;
@@ -251,7 +256,7 @@
 	else
 		return 0;
 
-	while (isspace((unsigned char)*p)) p++;
+	while (op_isspace((unsigned char)*p)) p++;
 	*value = p;
 	return gen_type;
 }
@@ -379,6 +384,7 @@
 	sk_X509_EXTENSION_pop_free(extlist, X509_EXTENSION_free);
 	return i;
 	}
+#endif/* OPERA_SMALL_VERSION */
 
 /* Config database functions */
 
@@ -420,6 +426,7 @@
 			ctx->db_meth->free_section(ctx->db, section);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 static char *nconf_get_string(void *db, char *section, char *value)
 	{
 	return NCONF_get_string(db, section, value);
@@ -483,7 +490,7 @@
 	return CONF_get_section(db, section);
 	}
 
-static X509V3_CONF_METHOD conf_lhash_method = {
+static const X509V3_CONF_METHOD conf_lhash_method = {
 conf_lhash_get_string,
 conf_lhash_get_section,
 NULL,
@@ -523,3 +530,4 @@
 	CONF_set_nconf(&ctmp, conf);
 	return X509V3_EXT_REQ_add_nconf(&ctmp, ctx, section, req);
 	}
+#endif
